DISK2  ;DISK2/ASM
 SHOREAD	CALL	DISPLY
 	DB	1DH,'Reading    ',0
 	LD	HL,READ
 	PUSH	HL
 	LD	HL,BADRD
 	PUSH	HL
 	LD	HL,SHOREAD	;where source from
 	JR	SHORWCOM	;go common
 SHOWRITE	CALL	DISPLY
 	DB	1DH,'Writing    ',0
 	LD	HL,WRITE
 	PUSH	HL
 	LD	HL,BADWRT
 	PUSH	HL
 	LD	HL,SHOWRITE
 	JR	SHORWCOM
 SHOVERIFY	CALL	SHOVERF
 	LD	HL,READ
 	PUSH	HL
 	LD	HL,BADRD
 	PUSH	HL
 	LD	HL,SHOVERIFY
 SHORWCOM	LD	(SHO003),HL
 	POP	HL
 	LD	(SHO002),HL
 	POP	HL
 	LD	(SHO001),HL
 	CALL	SHOWWH		;display drive,track,sec
 	CALL	SETDEND		;setup density
 	CALL	0		;set from above
 SHO001	EQU	$-2
 	POP	HL		;restore density
 	PUSH	AF
 	PUSH	HL		;HL=>AF
 	POP	AF
 	CALL	GETTYPE		;replace density
 	POP	AF		;get result back
 	RET	Z		;successful
 	CALL	0		;error type
 SHO002	EQU	$-2
 	RET	Z
 	CALL	DSTAT		;check status again
 	RET	NZ		;skip
 	JP	0		;try again
 SHO003	EQU	$-2
 SHOVERF	CALL	DISPLY
 	DB	1DH,'Verifying  ',0
 	RET
 SHOFMT	LD	A,(37EDH)	;get track
 	PUSH	BC		;save buffer
 	CALL	ASCII
 	LD	(FTR),A
 	LD	(FTR+1),BC
 	CALL	DRVASC
 	LD	(FDR),A		;put in string
 	POP	BC
 	CALL	DISPLY
 	DB	1DH,'Formatting Drive '
 FDR	DB	'x, Track '
 FTR	DB	'xxx.                ',0
 	CALL	WRITETR		;write the track
 	RET	Z		;successful
 	LD	HL,MEG0
 	BIT	6,A		;write protected?
 	JR	NZ,FMTER
 	LD	HL,MEG1
 	BIT	5,A		;write fault?
 	JR	NZ,FMTER
 	LD	HL,MEG2
 	BIT	2,A		;lost data?
 	RET	Z
 FMTER	PUSH	HL
 	JP	DISPLY		;print error
 MEG0	DB	10,'Diskette WRITE PROTECTED !',0
 	OR	1
 	RET			;return with NZ flag
 MEG1	DB	10,'Write Fault FROM DRIVE !',0
 	OR	1
 	RET
 MEG2	DB	10,'DATA LOST during Track Write !',0
 	OR	1
 	RET
 CNTOTAL	LD	BC,(TRACKS)
 	LD	B,0		;BC = track count
 	OR	A		;get type
 	CALL	GETTYPE
 	PUSH	AF
 	BIT	5,A
 	LD	A,10
 	LD	HL,0
 	JR	Z,CNTLP
 	LD	A,18
 CNTLP	ADD	HL,BC		;add 'em
 	DEC	A		;go till sector count
 	JR	NZ,CNTLP
 	POP	AF
 	BIT	5,A
 	RET	Z
 	LD	BC,-8		;adjust for single tk 0
 	ADD	HL,BC
 	RET
 MVERIFY	PUSH	HL		;save count
 	LD	HL,SHOVERIFY	;routine address
 	JR	MCOMM		;go common routine
 MREAD	PUSH	HL
 	LD	HL,SHOREAD
 	JR	MCOMM
 MWRITE	PUSH	HL
 	LD	HL,SHOWRITE
 MCOMM	LD	(MLADD),HL	;put in call code
 	POP	HL		;restore counter
 	LD	IX,DAMBUFF	;Data Address Marks
 MCLP	PUSH	HL		;save from call
 	CALL	INITBAD		;allow key input if bad
 	LD	A,(IX)		;get DAM
 	CP	0A0H
 	CALL	C,BADLMD	;bad write byte
 	CP	0C0H
 	CALL	NC,BADLMD	;this way bad too
 	LD	(WRTYPE),A	;pass to write command
 	CALL	0		;call the read/write/ver
 MLADD	EQU	$-2
 	POP	HL		;restore count
 	EX	AF,AF'		;get write byte
 	LD	(IX),A		;put in buffer
 	INC	IX		;bump buffer
 	EX	AF,AF'		;get result back
 	RET	C		;c = cancel routine
 	CALL	NEXSEC		;advance DE
 	JR	NC,MALDD00	;continue
 	LD	HL,0		;else done with track
 	CCF
 	RET
 MALDD00	DEC	HL
 	LD	A,H
 	OR	L
 	RET	Z		;done if yes
 	CALL	BUFFEREND	;buffer at end of memory?
 	RET	Z		;at end of memory
 	JR	MCLP		;do some more
 SMOUNT	PUSH	HL		;mount source disk
 	LD	HL,MOUNTSRC
 	JR	MOUNTC
 DMOUNT	PUSH	HL		;mount dest disk
 	LD	HL,MOUNTDES
 MOUNTC	LD	(MOUNTJ),HL	;save jump vector
 	POP	HL
 	LD	A,(MFLAG)	;get mount flag
 	DEC	A		;-1 = no mount wait
 	RET	Z
 	JP	0		;else display prompt
 MOUNTJ	EQU	$-2
 DRVSAME	PUSH	BC		;save to use
 	LD	A,(SDRIVE)	;get source drive
 	LD	B,A
 	LD	A,(DDRIVE)	;dest drive
 	CP	B		;same?
 	POP	BC
 	RET			;that's all here
 WRITETR	PUSH	BC		;save load address
 	CALL	TRWRITE		;write the track
 	POP	BC		;load back
 	RET	Z		;done
 TRWRITE	CALL	SELECT		;try again
 	RET	NZ		;not ready
 	CALL	SELDEN		;select density
 	LD	HL,37ECH	;point to FDC
 	LD	DE,37EFH	;data address
 	DI			;disable
 	LD	(HL),0F4H	;write track code
 	CALL	WXFER		;write the data
 	AND	0E4H		;error status
 	RET			;done
 BUFFEREND	LD	A,(TOPMEM+1)	;get msb topmem
 	CP	B		;test for buffer end
 	SCF			;must clear carry
 	CCF
 	RET			;back with Z flag
 BADLMD	LD	A,0A8H
 	RET
;write the data
 	AND	0E4H		;error status
 	RET			;done
 BUFFEREND	LD	A,(TOPMEM+1)	;get msb topmem
 	CP	B		;test for buffer end
 	SCF			