FORMAT ;FORMAT/ASM
 FORMAT	CALL	BUILDTRK
 	CALL	SHOFMT
 	RET	NZ
 	LD	DE,(TRACKS)
 	LD	A,(37EDH)
 	INC	A
 	CP	E
 	RET	Z
 	CALL	STEPIN		;move head in
 	JR	FORMAT
 BUILDTRK	OR	A
 	CALL	GETTYPE
 	LD	HL,ORDER
 	BIT	5,A
 	JR	Z,GOTORD
 	LD	A,(37EDH)
 	OR	A
 	LD	HL,DORDER
 	JR	NZ,GOTORD
 	LD	HL,ORDER
 GOTORD	LD	C,(HL)		;get sectors/track
 	INC	HL
 	LD	E,(HL)		;get sector order table
 	INC	HL
 	LD	D,(HL)
 	INC	HL
 	CALL	ORDNEW		;3 rotations
 	PUSH	DE		;save it
 	LD	DE,BUFFER
 	EX	DE,HL		;hl => buffer, de =>table
 	CALL	MOVEIN		;move the bytes in
 	LD	(DESVE),DE	;save DE position
 SECLP	CALL	MOVEIN
 	CALL	MOVEIN
 	LD	(HL),0FEH
 	INC	HL
 	LD	A,(37EDH)	;get track
 	LD	(HL),A
 	INC	HL
 	LD	(HL),0		;head
 	INC	HL
 	EX	(SP),HL		;get sector order
 	LD	A,(HL)		;get sector number
 	INC	HL
 	EX	(SP),HL		;put it back
 	LD	(HL),A		;put in buffer
 	INC	HL
 	LD	(HL),1		;length of sector
 	INC	HL
 	LD	(HL),0F7H	;generate CRC
 	INC	HL
 	CALL	MOVEIN
 	CALL	MOVEIN
 	CALL	MOVEIN
 	LD	(HL),0FBH	;Data address mark
 	INC	HL
 	LD	A,0		;fill byte
 	CALL	FILL		;fill for 256 bytes
 	LD	(HL),0F7H	;CRC for data
 	INC	HL
 	CALL	MOVEIN
 	LD	DE,0
 DESVE	EQU	$-2
 	DEC	C		;sector count -1
 	JR	NZ,SECLP	;sector loop
 	INC	SP		;adjust stack
 	INC	SP
 	DEC	DE
 	LD	A,(DE)
 	CALL	FILL		;fill to end byte
 	LD	BC,BUFFER	;point to the buffer
 RET	RET			;done
 MOVEIN	LD	A,(DE)		;get table byte
 	LD	B,A		;# bytes to go
 	INC	DE
 	LD	A,(DE)		;byte to fill with
 	INC	DE		;point to next one
 FILL	LD	(HL),A		;put in buffer
 	INC	HL
 	DJNZ	FILL
 	RET
 ORDER	DB	10		;sectors/track
 	DW	ORDERS		;single sector order
 	DB	1FH,0FFH	;count,byte
 	DB	3,0
 	DB	3,0
 	DB	0BH,0FFH
 	DB	3,0
 	DB	3,0
 	DB	0BH,0FFH	;gaps
 DORDER	DB	18		;sectors/track
 	DW	ORDERD		;double sector order
 	DB	3EH,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 	DB	0CH,0
 	DB	3,0F5H
 	DB	16H,4EH
 ORDERS	DB	0,5,1,6,2,7,3,8,4,9
 ORDERD	DB	0,6,12,1,7,13,2,8,14
 	DB	3,9,15,4,10,16,5,11,17
 ORDNEW	PUSH	BC		;save these
 	PUSH	DE
 	PUSH	HL		;save everything
 	EX	DE,HL		;HL = order table
 	LD	B,3		;3 shifts
 	DEC	C		;one less than # sectors
 	OR	A
 	CALL	GETTYPE
 	BIT	5,A
 	JR	Z,ORDNEW1
 	LD	B,4		;4 shifts double den
 ORDNEW1	PUSH	BC		;save counters
 	LD	A,(HL)		;get table byte
 	PUSH	HL		;save table start
 	INC	HL		;look at 2nd one
 ORDNEW2	LD	E,(HL)		;get 2nd byte
 	LD	(HL),A		;put 1st one there
 	LD	A,E		;get 2nd one
 	INC	HL		;go to next table byte
 	DEC	C		;continue through table
 	JR	NZ,ORDNEW2
 	POP	HL		;restore table pointer
 	LD	(HL),A		;put last byte in 1st
 	POP	BC		;get counters back
 	DJNZ	ORDNEW1		;go again
 	POP	HL
 	POP	DE		;restore these
 	POP	BC
 	RET
 SETDEN	LD	A,(37EDH)	;get track from FDC
 	JR	SETDENC
 SETDEND	LD	A,D		;from DE
 SETDENC	EX	AF,AF'		;save it here
 	LD	(SETDHL),HL	;save HL
 	OR	A		;clear carry
 	CALL	GETTYPE		;get drive type
 	POP	HL		;return address
 	SCF			;set to put in table
 	PUSH	AF		;save here
 	PUSH	HL		;put return address back
 	EX	AF,AF'		;get track back
 	OR	A		;set flags
 	JR	NZ,SETDRT	;return if not 0
 	EX	AF,AF'		;get table value back
 	RES	5,A		;make it single density
 	SCF
 	CALL	GETTYPE
 SETDRT	LD	HL,0		;get HL back
 SETDHL	EQU	$-2
 	RET			;done
ck back
 	OR	A		;set flags
 	JR	NZ,SETDRT	;return if not 0
 	EX	AF,AF'		;get table value back
 	RES	5,A		;make it single density
 	SCF
 	CALL	GETTYPE
